import create from 'zustand'
import { PointerLockControls } from '@react-three/drei'

type State = {
  pointerLockControls: PointerLockControls | undefined
  pointerLocked: boolean
  setPointerLockStatus: (status: boolean) => void
  setPointerLockControls: (controls: PointerLockControls) => void
}

const useStore = create<State>((set) => ({
  pointerLockControls: undefined,
  pointerLocked: false,
  setPointerLockStatus: (status) => set(() => ({ pointerLocked: status })),
  setPointerLockControls: (controls) => set(() => ({ pointerLockControls: controls })),
}))

export default useStore
